/**
 * Thievery section of Varanar, Morning Three.
 * @param {MorningThreeController} controller The Morning Three controller.
 */
function MorningThreeReturnEgg(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = MorningThreeThieveryChoice.RETURN;
    var reqController = ctrl.thievery;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var dick = ctrl.misc.dick();
        var She = dick ? `She` : `He`;
        var he = She.toLowerCase();
        var Her = dick ? `Her` : `His`;
        var his = Her.toLowerCase();
        var Him = dick ? `Her` : `Him`;
        var her = Him.toLowerCase();
        var toReturn = `[p]
                            You hand the egg back to the cyan kobold, staring ${her} down with the most disappointed, betrayed face you can muster.
                            ${She} covers ${his} face with ${his} arms, almost as if ${he} [b]expects[/b] you to hit ${her}.
                            ${Her} guard slowly lowers as ${he} realizes no blow is coming.
                            You tell ${her} you won't hit ${her}, but ${he}'d better think twice before trying to steal from you again.
                            You might not be so forgiving next time.
                        [/p]
                        [p]
                            Almost grovelling before you, the cyan kobold thanks you for your mercy.
                            After a dismissive gesture, ${he} disappears into the crowd, probably off to go scam someone else.
                            Is this how it feels like to be the one [i]catching[/i] a thief instead of being the thief getting caught?
                            The rush of [b]power[/b], the feeling of utter [b]dominance[/b] and [b]righteousness[/b], actually having the [b]moral highgrounds[/b],
                            is this how knights feel [b]all[/b] of the time?!
                            Darnit, you should have stopped one of those dragons you saw earlier, to ask them what it's like to be a knight.
                        [/p]
                        [p]
                            With the thief having vanished, you decide to stick around and see what happens to the bird on stage.
                            The crowd's relentless hurling of spoilt food continues for the better half of an hour.
                            Then, with the mob running out of things to throw at him, one of the guardsmen, a heavily battle-scarred feline,
                            approaches the avian from behind.
                        [/p]
                        [p]
                            With a single [b]swipe[/b] of the cat's clawed hand, the falcon's pants are ripped to shreds.
                            Kicking apart the bird's legs, the guardsman lowers his own trousers.
                            You watch on in horror, out of sheer morbid curiosity, as the bird begins to [b]beg[/b] for mercy,
                            while the feline lines up his barbed member with the criminal's unlubed feathery butthole.
                            Then, under the exuberant cheers of the crowd, he thrusts forward,
                            the avian squawking in pain and dishonor as his last bit of diginity is publically torn away from him.
                        [/p]
                        [p]
                            While the cat begins to violently hump away at the prisoner's rear, the very pillory itself rocking back and forth with every thrust,
                            you notice a small line starting to form near the steps leading up to the stage.
                            People are paying the guards, for what you can only assume to be their own turn with the bound falcon's ass.
                        [/p]
                        [p]
                            You aren't sure how to feel about this.
                            Turning prisoners into unwilling prostitutes seems morally [b]wrong[/b].
                            But then again, perhaps the bird is a rapist himself.
                            Maybe they're just doing to him what he did to someone else.
                            Either way, you now begin to realize why the guards of Varanar are widely praised as being highly effective at what they do.
                            You wouldn't want to get caught stealing, knowing something like [b]this[/b] might happen to you.
                        [/p]
                        [p]
                            You stick around for a little bit longer, to confirm your suspicions.
                            Indeed, as the feline finishes up and steps aside, the next person in line gets up on stage.
                            A big, burly horse.
                            There won't be much of the falcon left for the rest to enjoy after [i]that guy[/i] is done with him.
                            You turn around and walk away as the equine lowers his pants,
                            not interested in watching half the town have their way with the poor guy who got caught.
                            After all, there [i]are[/i] other things to do on the market square, apart from fucking captive birds.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.nextSceneName, ctrl.nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.returnEgg.change();
        part += buildChoice();
        if (!ctrl.nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.nextSceneReady) {
            registerContinueListener();
        }
    };
}
