/**
 * Flee section of Varanar, Night Two.
 * @param {NightTwoController} controller The Night Two controller.
 */
function NightTwoHideStay(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new NightTwoHideStayContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var pants = ctrl.misc.pants();
        var shirt = ctrl.misc.shirt();
        var clothes = shirt || pants;
        var toReturn = `[p]
                            While you would [b]love[/b] to [b]rip his nuts off[/b] with your sharp claws,
                            you simply can't risk the human calling his buddies over before he goes down.
                            There's no way you can take on all of them, unless they each approach one of at atime with their pants down and their dicks out.
                            While you [b]hate[/b] being forced to do this, you're just going to have to sit here and be quiet while the dehydrated drunkard does his thing.
                        [/p]
                        [p]
                            The man lets out a loud sigh of relief as he continues to let out an entire night's worth of booze-turned-urine,
                            a considerable puddle of the stuff forming on the ground right next to you.
                            You try to scooch over, to scuttle to the side just a little bit more to avoid the absolutely [b]revolting[/b] liquid,
                            yet after managing to spare yourself for half an inch more, there is simply nowhere left to run.
                            You almost [b]vomit[/b] as you feel the lukewarm fluid flow around your scaly hand, placed on the ground to keep you balanced,
                            but knowing your very life is at stake, you remain staunch and stalwart, resolute and unwavering.
                        [/p]
                        [p]
                            However, there are limits to your determination, limits which are put to the test as the ruffian begins to wobble on his feet,
                            his steady stream of urine erratically flailing about, splatterings of piss ${clothes ? `matting your clothing` : `befouling your scales`}.
                            As the human nearly topples over fully, his torrent deviates the most, the flow splashing directly against your face for just a brief moment,
                            completely [b]sullying[/b] your once-clean visage, drenching you in foul-smelling secretions,
                            your stomach managing to retain its contents by your sheer will to live alone.
                        [/p]
                        [p]
                            While your [b]hatred[/b] for the hoodlum runs deep, and the urge to attack him, to [b]maim[/b] him,
                            to [b]scar[/b] him for [/b]life[/b] as punishment for outright taking a [b]piss[/b] on you,
                            you don't even [b]dare[/b] to wipe your face out of fear that he'll notice.
                            His warm urine nauseatingly runs down your forehead and alongside your muzzle, before dripping to the ground below.
                            Luckily, none of it runs down your neck.
                        [/p]
                        [p]
                            Not long after being outright [b]sprayed[/b], the flood of vile fluid begins to falter.
                            After squirting out a final few jets of piss, and shaking off any lingering droplets,
                            the man repackages his flaccid cock, sloppily buttons up his pants, and walks away,
                            leaving you huddled up in a puddle of his slowly cooling mess.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = ctrl.hideStay.continued() ? "disabled" : "";
        var isSelected = ctrl.hideStay.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.hideStay.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.hide.get() !== NightTwoHideChoice.STAY) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.hideStay.change();
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.hide.get() !== NightTwoHideChoice.STAY) {
            return;
        }

        next.registerListeners();

        if (ctrl.hideStay.continued()) {
            return;
        }

        registerNextListener();
    };
}
